commit 9fdf7cdb6b00c6d962959c27a057beb91e23b219
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Oct 27 14:54:13 2016 +0100

    Fix target selectors in uniform_inside_sphere_distribution tests
    
    	* testsuite/ext/random/uniform_inside_sphere_distribution/cons/
    	default.cc: Fix effective target selector.
    	* testsuite/ext/random/uniform_inside_sphere_distribution/cons/
    	parms.cc: Likewise.
    	* testsuite/ext/random/uniform_inside_sphere_distribution/operators/
    	equal.cc: Likewise.
    	* testsuite/ext/random/uniform_inside_sphere_distribution/operators/
    	generate.cc: Likewise.
    	* testsuite/ext/random/uniform_inside_sphere_distribution/operators/
    	inequal.cc: Likewise.
    	* testsuite/ext/random/uniform_inside_sphere_distribution/operators/
    	serialize.cc: Likewise.

diff --git a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/default.cc
index 79ae488..ff5bcb3 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/default.cc
@@ -1,4 +1,4 @@
-// { dg-do run { target cxx11 } }
+// { dg-do run { target c++11 } }
 // { dg-require-cstdint "" }
 //
 // Copyright (C) 2014-2016 Free Software Foundation, Inc.
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/parms.cc b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/parms.cc
index 924b997..6a6ea2c 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/parms.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/cons/parms.cc
@@ -1,4 +1,4 @@
-// { dg-do run { target cxx11 } }
+// { dg-do run { target c++11 } }
 // { dg-require-cstdint "" }
 //
 // Copyright (C) 2014-2016 Free Software Foundation, Inc.
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/equal.cc
index 370ee56..1210946 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/equal.cc
@@ -1,4 +1,4 @@
-// { dg-do run { target cxx11 } }
+// { dg-do run { target c++11 } }
 // { dg-require-cstdint "" }
 //
 // Copyright (C) 2014-2016 Free Software Foundation, Inc.
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/generate.cc b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/generate.cc
index 60d76f3..e9a7ca7 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/generate.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/generate.cc
@@ -1,4 +1,4 @@
-// { dg-do run { target cxx11 } }
+// { dg-do run { target c++11 } }
 // { dg-require-cstdint "" }
 //
 // Copyright (C) 2014-2016 Free Software Foundation, Inc.
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/inequal.cc
index 0256d47..ca0d380 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/inequal.cc
@@ -1,4 +1,4 @@
-// { dg-do run { target cxx11 } }
+// { dg-do run { target c++11 } }
 // { dg-require-cstdint "" }
 //
 // Copyright (C) 2014-2016 Free Software Foundation, Inc.
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/serialize.cc
index d03ce35..89eb604 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_inside_sphere_distribution/operators/serialize.cc
@@ -1,4 +1,4 @@
-// { dg-do run { target cxx11 } }
+// { dg-do run { target c++11 } }
 // { dg-require-cstdint "" }
 //
 // Copyright (C) 2014-2016 Free Software Foundation, Inc.